Index: gs2-extensions/gsdl-amp/trunk/CASCADE-MAKE.sh
===================================================================
--- gs2-extensions/gsdl-amp/trunk/CASCADE-MAKE.sh	(revision 22236)
+++ gs2-extensions/gsdl-amp/trunk/CASCADE-MAKE.sh	(revision 22237)
@@ -1,5 +1,5 @@
 #!/bin/bash
 
-cd lib ; source cascade-lib.bash; cd ..
+cd cascade-make/lib ; source cascade-lib.bash; cd ../..
 
 for d in packages ; do
Index: gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE.sh
===================================================================
--- gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE.sh	(revision 22236)
+++ gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE.sh	(revision 22237)
@@ -2,5 +2,5 @@
 
 
-for d in MYSQL LIBPNG APACHE-PASS1 PHP  ; do
+for d in MYSQL LIBPNG APACHE PHP  ; do
   echo "    Running CASCADE-MAKE/$d.sh $*"
 
Index: gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/APACHE-PASS1.sh
===================================================================
--- gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/APACHE-PASS1.sh	(revision 22236)
+++ 	(revision )
@@ -1,29 +1,0 @@
-#!/bin/bash
-
-package=httpd
-version=-2.2.15
-
-progname=$0
-
-source ../bin/script/test-setup.bash
-source ../lib/cascade-lib.bash
-
-prefix=$GEXTAMP_INSTALLED
-
-if [ $COMPILE_UP_APACHE_HTTPD = "1" ] ; then
-  opt_run_untar $force_untar $auto_untar $package $version
-  opt_run_configure $force_config $auto_config $package $version "$prefix" \
-    "--with-layout=Apache \
-     --enable-so"
-
-  opt_run_make $compile   $package $version
-  opt_run_make $install   $package $version "install"
-  opt_run_make $clean     $package $version "clean"
-  opt_run_make $distclean $package $version "distclean"
-
-  opt_run_tarclean $tarclean $package $version
-else
-  echo "Using Apache HTTPD that is provided externally to the extension at:"
-  echo "  $APACHE_HTTPD_HOME"
-  echo ""
-fi
Index: gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/APACHE-PASS2.sh
===================================================================
--- gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/APACHE-PASS2.sh	(revision 22236)
+++ 	(revision )
@@ -1,35 +1,0 @@
-#!/bin/bash
-
-package=httpd
-version=-2.2.15
-
-progname=$0
-
-source ../bin/script/test-setup.bash
-source ../lib/cascade-lib.bash
-
-prefix=$GEXTAMP_INSTALLED
-
-opt_run_untar $force_untar $auto_untar $package $version
-
-# Need to force reconfigure -- that's why this file is called ..PASS2.sh
-force_config=1
-opt_run_configure $force_config $auto_config $package $version "$prefix" \
-  "--with-layout=Apache \
-   --activate-module=src/modules/php5/libphp5.a"
-
-
-#   --datadir=$GEXTAMP_INSTALLED \
-#   --sysconfdir=$GEXTAMP_INSTALLED/conf \
-#   --localstatedir=$GEXTAMP_INSTALLED"
-
-
-opt_run_make $compile   $package $version
-opt_run_make $install   $package $version "install"
-opt_run_make $clean     $package $version "clean"
-opt_run_make $distclean $package $version "distclean"
-
-opt_run_tarclean $tarclean $package $version
-
-
-
Index: gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/APACHE.sh
===================================================================
--- gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/APACHE.sh	(revision 22237)
+++ gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/APACHE.sh	(revision 22237)
@@ -0,0 +1,26 @@
+#!/bin/bash
+
+package=httpd
+version=-2.2.15
+
+progname=$0
+
+source ../cascade-make/lib/cascade-lib.bash
+
+prefix=$GEXTAMP_INSTALLED
+
+if [ $COMPILE_UP_APACHE_HTTPD = "1" ] ; then
+  opt_run_untar $force_untar $auto_untar $package $version
+  opt_run_configure $force_config $auto_config $package $version "$prefix" --with-layout=Apache --enable-so
+
+  opt_run_make $compile   $package $version
+  opt_run_make $install   $package $version "install"
+  opt_run_make $clean     $package $version "clean"
+  opt_run_make $distclean $package $version "distclean"
+
+  opt_run_tarclean $tarclean $package $version
+else
+  echo "Using Apache HTTPD that is provided externally to the extension at:"
+  echo "  $APACHE_HTTPD_HOME"
+  echo ""
+fi
Index: gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/LIBPNG.sh
===================================================================
--- gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/LIBPNG.sh	(revision 22236)
+++ gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/LIBPNG.sh	(revision 22237)
@@ -6,6 +6,5 @@
 progname=$0
 
-source ../bin/script/test-setup.bash
-source ../lib/cascade-lib.bash
+source ../cascade-make/lib/cascade-lib.bash
 
 prefix=$GEXTAMP_INSTALLED
Index: gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/MYSQL.sh
===================================================================
--- gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/MYSQL.sh	(revision 22236)
+++ gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/MYSQL.sh	(revision 22237)
@@ -6,6 +6,5 @@
 progname=$0
 
-source ../bin/script/test-setup.bash
-source ../lib/cascade-lib.bash
+source ../cascade-make/lib/cascade-lib.bash
 
 prefix=$GEXTAMP_INSTALLED
Index: gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/PHP.sh
===================================================================
--- gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/PHP.sh	(revision 22236)
+++ gs2-extensions/gsdl-amp/trunk/packages/CASCADE-MAKE/PHP.sh	(revision 22237)
@@ -8,6 +8,5 @@
 progname=$0
 
-source ../bin/script/test-setup.bash
-source ../lib/cascade-lib.bash
+source ../cascade-make/lib/cascade-lib.bash
 
 prefix=$GEXTAMP_INSTALLED
@@ -15,14 +14,5 @@
 opt_run_untar $force_untar $auto_untar $package $version
 
-opt_run_configure $force_config $auto_config $package $version "$prefix" \
-  "--with-mysql=$prefix \
-   --with-png-dir=$prefix \
-   --with-apxs2=$prefix/bin/apxs \
-   --with-gd"
-
-# --with-apxs2 \
-# --with-apache=../$apache_version \
-# --with-jpeg-dir=/usr/local/ --with-zlib-
-
+opt_run_configure $force_config $auto_config $package $version "$prefix" --with-mysql=$prefix --with-png-dir=$prefix --with-apxs2=$prefix/bin/apxs --with-gd
 
 opt_run_make $compile   $package $version
@@ -32,5 +22,2 @@
 
 opt_run_tarclean $tarclean $package $version
-
-
-
Index: gs2-extensions/gsdl-amp/trunk/setup.bash
===================================================================
--- gs2-extensions/gsdl-amp/trunk/setup.bash	(revision 22236)
+++ gs2-extensions/gsdl-amp/trunk/setup.bash	(revision 22237)
@@ -6,5 +6,5 @@
 if [ "x$GEXTAMP" = "x" ] ; then
   export GEXTAMP=`pwd`
-  export GEXTAMP_INSTALLED=$GEXTAMP/installed
+  export GEXTAMP_INSTALLED=$GEXTAMP/installed/linux
 
   export PATH=$GEXTAMP_INSTALLED/bin:$PATH
@@ -27,5 +27,5 @@
 	  export COMPILE_UP_APACHE_HTTPD=0
       fi
-  if
+  fi
 
 